execute as @a[tag=OnTeleport] if data entity @s {OnGround:1b} run tag @s remove OnTeleport

execute as @a unless score @s vanillap_tstate = @s vanillap_tstate at @s run function vanilla_portal:transform/test_set
execute as @a if score @s vanillap_tstate = @s vanillap_tstate at @s run function vanilla_portal:transform/test_reset
execute as @a if data entity @s SelectedItem.components."minecraft:custom_data"."vanilla_portal:data".transformable run function vanilla_portal:transform/check_main
execute as @a if data entity @s Inventory[{Slot:-106b}].components."minecraft:custom_data"."vanilla_portal:data".transformable run function vanilla_portal:transform/check_other

execute as @a[tag=BackforceLock] run tag @s add VanillaPBKF
execute as @a at @s anchored eyes positioned ^ ^ ^ run function vanilla_portal:deal_with_spawner
execute unless entity @a[scores={vanillap_place=1..}] as @e[type=armor_stand,tag=VanillaP,tag=Spawner] at @s run function vanilla_portal:deal_with_spawner/regular_check
execute if entity @a[scores={vanillap_place=1..}] as @e[type=armor_stand,tag=VanillaP,tag=Spawner] at @s run function vanilla_portal:deal_with_spawner/check_if_replaced
execute as @a run scoreboard players reset @s vanillap_place

execute as @a at @s if data entity @s Inventory[].components."minecraft:custom_data"."vanilla_portal:data".setDimension run function vanilla_portal:set_dimension
execute as @a at @s if data entity @s Inventory[].components."minecraft:custom_data"."vanilla_portal:data".setTargetPlayer run function vanilla_portal:set_target_player

execute as @e[type=armor_stand,tag=VanillaP,tag=PortalTarget] at @s run function vanilla_portal:portal_target
execute as @e[type=armor_stand,tag=VanillaP,tag=BuildPortal] at @s run function vanilla_portal:build_portal
execute as @e[type=armor_stand,tag=VanillaP,tag=BackTarget] at @s run function vanilla_portal:back_target
execute as @e[type=armor_stand,tag=VanillaP,tag=AreaTarget] at @s run function vanilla_portal:area_target
execute as @e[type=armor_stand,tag=VanillaP,tag=Portal] unless entity @s[tag=Expanded] at @s run function vanilla_portal:portal_check
execute as @e[type=armor_stand,tag=VanillaP,tag=Portal,tag=Expanded] at @s run function vanilla_portal:portal_check_expanded
execute as @a run scoreboard players reset @s vanillap_expand

function vanilla_portal:ender_book/check_feedback
function vanilla_portal:ender_book/check_store
execute as @a[scores={vanillap_rindex=1..}] anchored eyes at @s run function vanilla_portal:ender_book/check_throw
execute as @a[scores={vanillap_uindex=1..}] anchored eyes at @s run function vanilla_portal:ender_book/check_use

execute as @a run function vanilla_portal:combine_triggers
execute as @e[type=armor_stand,tag=VanillaP,tag=AreaTeleporter] at @s run function vanilla_portal:area/tick
execute as @a[tag=VanillaPC] run function vanilla_portal:trigger_check
execute as @a[tag=VanillaPBKF] at @s run function vanilla_portal:backforce
execute as @a[tag=VanillaPATH] at @s run function vanilla_portal:attached
execute as @a[tag=VanillaPPYT] at @s run function vanilla_portal:player_totem
execute as @a[tag=VanillaPARE] at @s run function vanilla_portal:area
execute as @e[type=armor_stand,tag=VanillaP,tag=AreaDo] at @s run function vanilla_portal:area/teleport
execute as @a[tag=VanillaPTPR] run function vanilla_portal:teleport
execute as @a[tag=VanillaPCALL] run function vanilla_portal:calling

execute unless entity @a[tag=HoldingBook] if entity @e[tag=BanFeedback] run function vanilla_portal:allow_feedback

data remove storage vanilla_portal:buffer Book
data remove storage vanilla_portal:buffer Text
data remove storage vanilla_portal:buffer ItemModifier
data remove storage vanilla_portal:buffer Teleport